<?php

$page = "confessions";
include "header.php";


// DISPLAY ERROR PAGE IF USER IS NOT LOGGED IN AND ADMIN SETTING REQUIRES REGISTRATION
if( !$user->user_exists && !$setting['setting_permission_confession'] )
{
  $page = "error";
  $smarty->assign('error_header', 639);
  $smarty->assign('error_message', 656);
  $smarty->assign('error_submit', 641);
  include "footer.php";
}

// DISPLAY ERROR PAGE IF NO OWNER
if( !$owner->user_exists )
{
  $page = "error";
  $smarty->assign('error_header', 639);
  $smarty->assign('error_message', 828);
  $smarty->assign('error_submit', 641);
  include "footer.php";
}

// ENSURE confessionS ARE ENABLED FOR THIS USER
if( !$owner->level_info['level_confession_allow'] )
{
  header("Location: ".$url->url_create('profile', $owner->user_info['user_username']));
  exit();
}


// INIT VARS
if(isset($_POST['p'])) { $p = $_POST['p']; } elseif(isset($_GET['p'])) { $p = $_GET['p']; } else { $p = 1; }


// SET PRIVACY LEVEL AND WHERE CLAUSE
$privacy_max = $owner->user_privacy_max($user);
$where = "(confession_privacy & $privacy_max)";


// CREATE confession OBJECT
$entries_per_page = (int)$owner->level_info['level_confession_entries'];
if($entries_per_page <= 0) { $entries_per_page = 10; }
$confession = new se_confession($owner->user_info[user_id]);


// GET TOTAL ENTRIES, MAKE ENTRY PAGES, GET ENTRY ARRAY
$total_confessions = $confession->confession_total($where);
$page_vars = make_page($total_confessions, $entries_per_page, $p);
$confessions = $confession->confession_list($page_vars[0], $entries_per_page, "confession_date DESC", $where);


// SET SEO STUFF
$global_page_title = array(8700143, $owner->user_displayname);
$global_page_description = array(8700143, $owner->user_displayname);


// ASSIGN VARIABLES AND DISPLAY confession PAGE
$smarty->assign('confessions', $confessions);
$smarty->assign('total_confessions', $total_confessions);
$smarty->assign('p', $page_vars[1]);
$smarty->assign('maxpage', $page_vars[2]);
$smarty->assign('p_start', $page_vars[0]+1);
$smarty->assign('p_end', $page_vars[0]+count($confessions));
include "footer.php";
?>