<?

include_once "class_radcodes.php";

class rc_page extends rc_model 
{
  var $table = 'se_pages';
  var $pk = 'page_id';
   
  function insert($data)
  {
    if (!$data['page_key']) {
      $data['page_key'] = rc_toolkit::strip_text($data['page_name']);
    }
    $data['page_updated_at'] = rc_toolkit::db_to_datetime();  
    return parent::insert($data);
  }
  
  function update($id, $data)
  {
    $data['page_updated_at'] = rc_toolkit::db_to_datetime();
    return parent::update($id, $data);
  }
  
  function get_page_by_key($key)
  {
    return $this->get_record_by_criteria("page_key = '$key'");
  }
  
  function get_usermenu_items()
  {
  	global $setting;
  	
    $items = null; 	
    	
    // CACHING
    $cache_object = SECache::getInstance('serial');
    if( is_object($cache_object) )
    {
      $items = $cache_object->get('usermenu_pages');
    }
    
    // RETRIEVAL
    if( !is_array($items) )
    {
      $items = array();
      if (strlen($setting['setting_page_usermenu_ids'])) {
        
        $usermenu_pids = explode(',', $setting['setting_page_usermenu_ids']);

        $pids = join("','", $usermenu_pids);

        $query = "SELECT page_id, page_name, page_key FROM se_pages 
        WHERE page_id IN ('{$pids}')
        ORDER BY page_name ASC
        ";
        $res = $this->db->database_query($query);
        while ($r = $this->db->database_fetch_assoc($res)) {
          $items[$r['page_id']] = $r;
        }
        
      }
      
      if( is_object($cache_object) )
      {
        $cache_object->store($items, 'usermenu_pages');
      }
    }

  	return $items;
  }
  
  function get_topmenu_items()
  {
    global $setting;
    
    $items = null;  
      
    // CACHING
    $cache_object = SECache::getInstance('serial');
    if( is_object($cache_object) )
    {
      $items = $cache_object->get('topmenu_pages');
    }
    
    // RETRIEVAL
    if( !is_array($items) )
    {
      $items = array();
      
      if (strlen($setting['setting_page_topmenu_ids'])) {
        $topmenu_pids = explode(',', $setting['setting_page_topmenu_ids']);
        $pids = join("','", $topmenu_pids);
  
        $query = "SELECT page_id, page_name, page_key FROM se_pages 
        WHERE page_id IN ('{$pids}')
        ORDER BY page_name ASC
        ";
        $res = $this->db->database_query($query);
        while ($r = $this->db->database_fetch_assoc($res)) {
          $items[$r['page_id']] = $r;
        }
        
      }

      if( is_object($cache_object) )
      {
        $cache_object->store($items, 'topmenu_pages');
      }
    }

    return $items;
  }
  
}
