<?php


defined('SE_PAGE') or exit();

//Function for Thumbnail Creation 

function resizeImage($image,$thumb,$newImageWidth,$newImageHeight,$file_ext) {
	$width=	getWidth($image);
	$height=getHeight($image);
	$newImage = imagecreatetruecolor($newImageWidth,$newImageHeight);
	
    switch($file_ext)
    {
	case "jpeg":
	case "jpg":
		$source = imagecreatefromjpeg($image);
	 break;
	 case "gif":
		$source = imagecreatefromgif($image);	
	 break;
   }	

	imagecopyresampled($newImage,$source,0,0,0,0,$newImageWidth,$newImageHeight,$width,$height);
	imagejpeg($newImage,$thumb,90);
	chmod($thumb, 0777);
	return $thumb;
}
function getHeight($image) {
	$sizes = getimagesize($image);
	$height = $sizes[1];
	return $height;
}

function getWidth($image) {
	$sizes = getimagesize($image);
	$width = $sizes[0];
	return $width;
}
// End Of Thumbnail Creation

// THIS FUNCTION IS RUN WHEN A USER IS DELETED
// INPUT: $user_id REPRESENTING THE USER ID OF THE USER BEING DELETED
// OUTPUT: 
function deleteuser_upload($user_id) {
	global $database;

	// DELETE File Upload, Rating, downloads AND COMMENTS
	$database->database_query("DELETE FROM se_fileuploads LEFT JOIN se_filedownloads ON se_fileuploads.userupload_id=se_filedownloads.userupload_id LEFT JOIN se_fileratings ON se_fileuploads.userupload_id=se_fileratings.userupload_id  WHERE se_fileuploads.userupload_userid='$user_id'");

}

// END deleteuser_upload() FUNCTION

// THIS FUNCTION IS RUN DURING THE SEARCH PROCESS TO SEARCH THROUGH Files : 
// OUTPUT: 
function search_upload() {
	global $database, $url, $results_per_page, $p, $search_text, $t, $search_objects, $results, $total_results;

	// CONSTRUCT QUERY
	$file_query = "
	SELECT
	'1' as sub_type,	
  	  se_fileuploads.userupload_id AS file_id,
	  se_fileuploads.userupload_title AS title,
	  se_fileuploads.userupload_description AS description,
	  se_fileuploads.userupload_userthumbs AS thumb,	
	  se_users.user_id,
	  se_users.user_username,
	  se_users.user_photo,
	  se_users.user_fname,
	  se_users.user_lname
	FROM
	  se_fileuploads,
	  se_users,
	  se_levels
	WHERE
	  se_fileuploads.userupload_userid=se_users.user_id AND
	  se_users.user_level_id=se_levels.level_id AND
	  (
	    se_fileuploads.userupload_search='1' OR
	    se_levels.level_file_upload_search='0'
	  )
	  AND
	  (
	    se_fileuploads.userupload_title LIKE '%$search_text%' OR
	    se_fileuploads.userupload_description LIKE '%$search_text%'
	  )
	ORDER BY se_fileuploads.userupload_id DESC
	"; 
	//echo $file_query;
	// GET TOTAL RESULTS
	$total_files = $database->database_num_rows($database->database_query($file_query." LIMIT 201"));

	// IF NOT TOTAL ONLY
	if($t == "file") {

	  // MAKE File PAGES
	  $start = ($p - 1) * $results_per_page;
	  $limit = $results_per_page+1;

	  // SEARCH Files
	 $files = $database->database_query($file_query." LIMIT $start, $limit");
	  while($file_info = $database->database_fetch_assoc($files)) {

	    // CREATE AN OBJECT FOR USER
	    $profile = new se_user();
	    $profile->user_info[user_id] = $file_info[user_id];
	    $profile->user_info[user_username] = $file_info[user_username];
	    $profile->user_info[user_fname] = $file_info[user_fname];
	    $profile->user_info[user_lname] = $file_info[user_lname];
	    $profile->user_info[user_photo] = $file_info[user_photo];
	    $profile->user_displayname();

	    // RESULT IS A File
	    if($file_info[sub_type] == 1) {
	      $result_url = $url->url_create('fileuploads', $file_info[user_id], $file_info[file_id]);
	//echo $result_url;
	      $result_name = 7800137;
	      $result_desc = 7800138;
   	    } 
		
	        if($file_info['thumb']) {
			$thumb_path = "./userthumbs/thumbnail/".$file_info['thumb'];
		 }

	    // IF NO TITLE
	    if($file_info[title] == "") { SE_Language::_preload(589); SE_Language::load(); $file_info[title] = SE_Language::_get(589); }

	    // IF DESCRIPTION IS LONG
	    if(strlen($file_info[description]) > 150) { $file_info[description] = substr($file_info[description], 0, 147)."..."; }

	    $results[] = Array('result_url' => $result_url,
				'result_icon' => $thumb_path,
				'result_name' => $result_name,
				'result_name_1' => $file_info[title],
				'result_desc' => $result_desc,
				'result_desc_1' => $url->url_create('profile', $file_info[user_username]),
				'result_desc_2' => $profile->user_displayname,
				'result_desc_3' => $file_info[description]);
	  }

	  // SET TOTAL RESULTS
	  $total_results = $total_files;

	}

	// SET ARRAY VALUES
	SE_Language::_preload_multi(7800137, 7800138, 7800139);
	if($total_files > 200) { $total_files = "200+"; }
	$search_objects[] = Array('search_type' => 'file',
				'search_lang' => 7800139,
				'search_total' => $total_files);

} // END search_upload() FUNCTION


// THIS FUNCTION IS RUN WHEN GENERATING SITE STATISTICS
// INPUT: 
// OUTPUT: 
function site_statistics_fileuploads(&$args)
{
  global $database;
  
  $statistics =& $args['statistics'];
  
  // NOTE: CACHING WILL BE HANDLED BY THE FUNCTION THAT CALLS THIS
  
  $total = $database->database_fetch_assoc($database->database_query("SELECT COUNT(userupload_id) AS total FROM se_fileuploads"));
  $statistics['fileuploads'] = array(
    'title' => 7800147,
    'stat'  => (int) ( isset($total['total']) ? $total['total'] : 0 )
  );
  
  /*
  $total = $database->database_fetch_assoc($database->database_query("SELECT COUNT(media_id) AS total FROM se_media"));
  $statistics['media'] = array(
    'title' => 1000175,
    'stat'  => (int) ( isset($total['total']) ? $total['total'] : 0 )
  );
  
  $total = $database->database_fetch_assoc($database->database_query("SELECT COUNT(mediacomment_id) AS total FROM se_mediacomments"));
  $statistics['mediacomments'] = array(
    'title' => 1000176,
    'stat'  => (int) ( isset($total['total']) ? $total['total'] : 0 )
  );
  
  $total = $database->database_fetch_assoc($database->database_query("SELECT COUNT(mediatag_id) AS total FROM se_mediatags"));
  $statistics['mediatags'] = array(
    'title' => 1000177,
    'stat'  => (int) ( isset($total['total']) ? $total['total'] : 0 )
  );
  */
}

// END site_statistics_album() FUNCTION



?>