<?php

$page = "user_confession_listing";
include "header.php";


$task           = ( !empty($_POST['task'])          ? $_POST['task']          : ( !empty($_GET['task'])           ? $_GET['task']           : NULL ) );
$confession_id  = ( !empty($_POST['confession_id']) ? $_POST['confession_id'] : ( !empty($_GET['confession_id'])  ? $_GET['confession_id']  : NULL ) );


// ENSURE confessionS ARE ENABLED FOR THIS USER
if( !$user->level_info['level_confession_allow'] )
{
  header("Location: user_home.php");
  exit();
}


// GET PRIVACY SETTINGS
$level_confession_privacy = unserialize($user->level_info['level_confession_privacy']);
rsort($level_confession_privacy);
$level_confession_comments = unserialize($user->level_info['level_confession_comments']);
rsort($level_confession_comments);


// INITIALIZE VARIABLES
$is_error = FALSE;

$confession = new se_confession($user->user_info['user_id'], $confession_id);

if( $confession->confession_exists && $user->user_info['user_id']!=$confession->confession_info['confession_user_id'] )
{
  header('user_home.php');
  exit();
}

if( !$confession->confession_exists ) $confession->confession_info = array
(
  'confession_title'                => '',
  'confession_body'                 => '',
  'confession_confessioncat_id'     => 0,
  'confession_confessionsubcat_id'  => 0,
  'confession_search'               => 1,
  'confession_privacy'              => $level_confession_privacy[0],
  'confession_comments'             => $level_confession_comments[0]
);


// BEGIN POST ENTRY TASK
if( $task=="dosave" )
{
  $confession->confession_info['confession_id']                   = $_POST['confession_id'];
  $confession->confession_info['confession_title']                = censor($_POST['confession_title']);
  $confession->confession_info['confession_body']                 = censor(str_replace("\r\n", "<br />", $_POST['confession_body']));
  $confession->confession_info['confession_search']               = $_POST['confession_search'];
  $confession->confession_info['confession_privacy']              = $_POST['confession_privacy'];
  $confession->confession_info['confession_comments']             = $_POST['confession_comments'];
  $confession->confession_info['confession_confessioncat_id']     = $_POST['confession_confessioncat_id'];
  $confession->confession_info['confession_confessionsubcat_id']  = $_POST['confession_confessionsubcat_id'];
  
  // GET FIELDS
  $field = new se_field("confession");
  $field->cat_list(1, 0, 0, "confessioncat_id='{$confession->confession_info[confession_confessioncat_id]}'", "", "");
  $selected_fields = $field->fields_all;
  $is_error = $field->is_error;
  
  if( !$confession->confession_info['confession_id'] )
    $confession->confession_info['confession_id'] = NULL;
  
  // CHECK TO MAKE SURE TITLE HAS BEEN ENTERED
  if( !trim($confession->confession_info['confession_title']) )
    $is_error = 8700100;

  // CHECK TO MAKE SURE CATEGORY HAS BEEN SELECTED
  if( !$confession->confession_info['confession_confessioncat_id'] )
    $is_error = 8700101;
    
  // MAKE SURE SUBMITTED PRIVACY OPTIONS ARE ALLOWED, IF NOT, SET TO EVERYONE
  if( !in_array($confession->confession_info['confession_privacy'] , $level_confession_privacy ) )
    $confession->confession_info['confession_privacy']  = $level_confession_privacy[0] ;
  if( !in_array($confession->confession_info['confession_comments'], $level_confession_comments) )
    $confession->confession_info['confession_comments'] = $level_confession_comments[0];
  
  // CHECK THAT SEARCH IS NOT BLANK
  if( !$user->level_info['level_confession_search'] )
    $confession->confession_info['confession_search'] = 1;
  
  
  // IF NO ERROR, SAVE GROUP
  if( !$is_error )
  {
    // SET confession CATEGORY ID
    if( $confession->confession_info['confession_confessionsubcat_id'] && $confession->confession_info['confession_confessionsubcat_id'] )
      $confession->confession_info['confession_confessioncat_id'] = $confession->confession_info['confession_confessionsubcat_id'];
    
    $confession->confession_info['confession_id'] = $confession->confession_post(
      $confession->confession_info['confession_id'],
      $confession->confession_info['confession_title'],
      $confession->confession_info['confession_body'],
      $confession->confession_info['confession_confessioncat_id'],
      $confession->confession_info['confession_search'],
      $confession->confession_info['confession_privacy'],
      $confession->confession_info['confession_comments'],
      $field->field_query
    );
    
    // UPDATE LAST UPDATE DATE (SAY THAT 10 TIMES FAST)
    $user->user_lastupdate();
    
    // INSERT ACTION
    if( $confession_id )
    {
      $confession_title_short = $confession->confession_info['confession_title'];
      if( strlen($confession_title_short) > 100 ) $confession_title_short = substr($confession_title_short, 0, 97); $confession_title_short .= "...";
      $actions->actions_add(
        $user,
        "postconfession",
        array(
          $user->user_info['user_username'],
          $user->user_displayname,
          $confession->confession_info['confession_id'],
          $confession_title_short
        )
      );
    }
    
    header($confession_id ? "Location: user_confession.php" : "Location: user_confession_media.php?confession_id={$confession->confession_info['confession_id']}&justadded=1" );
    exit();
  }
}





// GET PREVIOUS PRIVACY SETTINGS
for($c=0;$c<count($level_confession_privacy);$c++) {
  if(user_privacy_levels($level_confession_privacy[$c]) != "") {
    SE_Language::_preload(user_privacy_levels($level_confession_privacy[$c]));
    $privacy_options[$level_confession_privacy[$c]] = user_privacy_levels($level_confession_privacy[$c]);
  }
}

for($c=0;$c<count($level_confession_comments);$c++) {
  if(user_privacy_levels($level_confession_comments[$c]) != "") {
    SE_Language::_preload(user_privacy_levels($level_confession_comments[$c]));
    $comment_options[$level_confession_comments[$c]] = user_privacy_levels($level_confession_comments[$c]);
  }
}


// GET FIELDS
$field = new se_field("confession", $confession->confessionvalue_info);
$field->cat_list(0, 0, 0, "", "", "");
$cat_array = $field->cats;
if( $is_error && $confession_info['confession_confessioncat_id'] )
{
  $selected_cat_array = array_filter($cat_array, create_function('$a', 'if($a["cat_id"] == "'.$confession_info['confession_confessioncat_id'].'") { return $a; }'));
  foreach( $selected_cat_array as $key=>$val )
  {
    $cat_array[$key]['fields'] = $selected_fields;
  }
}


// GET SUBCAT IF NECESSARY
$thiscat = $database->database_fetch_assoc($database->database_query("SELECT confessioncat_id, confessioncat_dependency FROM se_confessioncats WHERE confessioncat_id='{$confession->confession_info[confession_confessioncat_id]}'"));
if( !$thiscat['confessioncat_dependency'] )
{
  $confession->confession_info['confession_confessionsubcat_id'] = 0;
}
else
{
  $confession->confession_info['confession_confessionsubcat_id'] = $confession->confession_info['confession_confessioncat_id'];
  $confession->confession_info['confession_confessioncat_id'] = $thiscat['confessioncat_dependency'];
}


// REMOVE BREAKS
$confession->confession_info['confession_body'] = str_replace("<br />", "\r\n", $confession->confession_info['confession_body']);




// ASSIGN VARIABLES AND SHOW ADD GROUPS PAGE
$smarty->assign('is_error', $is_error);

$smarty->assign_by_ref('confession', $confession);
$smarty->assign_by_ref('cats', $cat_array);

$smarty->assign('privacy_options', $privacy_options);
$smarty->assign('comment_options', $comment_options);
include "footer.php";
?>